Package org.optaplanner.core.api.score.stream.uni

## Interface UniConstraintStream<A>

- Type Parameters:
    `A` - the type of the first and only fact in the tuple.
  All Superinterfaces:
    `ConstraintStream`
  All Known Subinterfaces:
    `InnerUniConstraintStream<A>`
  All Known Implementing Classes:
    `BavetAbstractUniConstraintStream`, `BavetFilterUniConstraintStream`, `BavetFromUniConstraintStream`, `BavetGroupBridgeUniConstraintStream`, `BavetJoinBridgeUniConstraintStream`, `BavetScoringUniConstraintStream`, `DroolsAbstractUniConstraintStream`, `DroolsExistsUniConstraintStream`, `DroolsFilterUniConstraintStream`, `DroolsFromUniConstraintStream`, `DroolsGroupingUniConstraintStream`, `DroolsScoringUniConstraintStream`

      public interface UniConstraintStream<A>
      extends ConstraintStream

  A `ConstraintStream` that matches one fact.
  See Also:
    `ConstraintStream`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `UniConstraintStream<A>` | `filter​(Predicate<A> predicate)` | Exhaustively test each fact against the `Predicate` and match if `Predicate.test(Object)` returns true.
    `<GroupKey_> UniConstraintStream<GroupKey_>` | `groupBy​(Function<A,​GroupKey_> groupKeyMapping)` | Convert the `UniConstraintStream` to a different `UniConstraintStream`, containing the set of tuples resulting from applying the group key mapping function on all tuples of the original stream.
    `<GroupKey_,​ResultContainer_,​Result_> BiConstraintStream<GroupKey_,​Result_>` | `groupBy​(Function<A,​GroupKey_> groupKeyMapping, UniConstraintCollector<A,​ResultContainer_,​Result_> collector)` | Convert the `UniConstraintStream` to a `BiConstraintStream`, consisting of unique tuples with two facts.
    `<GroupKeyA_,​GroupKeyB_> BiConstraintStream<GroupKeyA_,​GroupKeyB_>` | `groupBy​(Function<A,​GroupKeyA_> groupKeyAMapping, Function<A,​GroupKeyB_> groupKeyBMapping)` | Convert the `UniConstraintStream` to a `BiConstraintStream`, consisting of unique tuples with two facts.
    `<GroupKeyA_,​GroupKeyB_,​ResultContainer_,​Result_> TriConstraintStream<GroupKeyA_,​GroupKeyB_,​Result_>` | `groupBy​(Function<A,​GroupKeyA_> groupKeyAMapping, Function<A,​GroupKeyB_> groupKeyBMapping, UniConstraintCollector<A,​ResultContainer_,​Result_> collector)` | Combines the semantics of `groupBy(Function, Function)` and `groupBy(UniConstraintCollector)`.
    `<GroupKeyA_,​GroupKeyB_,​ResultContainerC_,​ResultC_,​ResultContainerD_,​ResultD_> QuadConstraintStream<GroupKeyA_,​GroupKeyB_,​ResultC_,​ResultD_>` | `groupBy​(Function<A,​GroupKeyA_> groupKeyAMapping, Function<A,​GroupKeyB_> groupKeyBMapping, UniConstraintCollector<A,​ResultContainerC_,​ResultC_> collectorC, UniConstraintCollector<A,​ResultContainerD_,​ResultD_> collectorD)` | Combines the semantics of `groupBy(Function, Function)` and `groupBy(UniConstraintCollector)`.
    `<ResultContainer_,​Result_> UniConstraintStream<Result_>` | `groupBy​(UniConstraintCollector<A,​ResultContainer_,​Result_> collector)` | Convert the `UniConstraintStream` to a different `UniConstraintStream`, containing only a single tuple, the result of applying `UniConstraintCollector`.
    `default <B> UniConstraintStream<A>` | `ifExists​(Class<B> otherClass, BiJoiner<A,​B> joiner)` | Create a new `UniConstraintStream` for every A where B exists for which the `BiJoiner` is true (for the properties it extracts from both facts).
    `<B> UniConstraintStream<A>` | `ifExists​(Class<B> otherClass, BiJoiner<A,​B>... joiners)` | As defined by `ifExists(Class, BiJoiner)`.
    `default <B> UniConstraintStream<A>` | `ifExists​(Class<B> otherClass, BiJoiner<A,​B> joiner1, BiJoiner<A,​B> joiner2)` | As defined by `ifExists(Class, BiJoiner)`.
    `default <B> UniConstraintStream<A>` | `ifExists​(Class<B> otherClass, BiJoiner<A,​B> joiner1, BiJoiner<A,​B> joiner2, BiJoiner<A,​B> joiner3)` | As defined by `ifExists(Class, BiJoiner)`.
    `default <B> UniConstraintStream<A>` | `ifExists​(Class<B> otherClass, BiJoiner<A,​B> joiner1, BiJoiner<A,​B> joiner2, BiJoiner<A,​B> joiner3, BiJoiner<A,​B> joiner4)` | As defined by `ifExists(Class, BiJoiner)`.
    `default UniConstraintStream<A>` | `ifExistsOther​(Class<A> otherClass)` | Create a new `UniConstraintStream` for every A, if another A exists that does not `#equals(Object)` the first.
    `default UniConstraintStream<A>` | `ifExistsOther​(Class<A> otherClass, BiJoiner<A,​A> joiner)` | Create a new `UniConstraintStream` for every A, if another A exists that does not `#equals(Object)` the first, and for which the `BiJoiner` is true (for the properties it extracts from both facts).
    `default UniConstraintStream<A>` | `ifExistsOther​(Class<A> otherClass, BiJoiner<A,​A>... joiners)` | As defined by `ifExistsOther(Class, BiJoiner)`.
    `default UniConstraintStream<A>` | `ifExistsOther​(Class<A> otherClass, BiJoiner<A,​A> joiner1, BiJoiner<A,​A> joiner2)` | As defined by `ifExistsOther(Class, BiJoiner)`.
    `default UniConstraintStream<A>` | `ifExistsOther​(Class<A> otherClass, BiJoiner<A,​A> joiner1, BiJoiner<A,​A> joiner2, BiJoiner<A,​A> joiner3)` | As defined by `ifExistsOther(Class, BiJoiner)`.
    `default UniConstraintStream<A>` | `ifExistsOther​(Class<A> otherClass, BiJoiner<A,​A> joiner1, BiJoiner<A,​A> joiner2, BiJoiner<A,​A> joiner3, BiJoiner<A,​A> joiner4)` | As defined by `ifExistsOther(Class, BiJoiner)`.
    `default <B> UniConstraintStream<A>` | `ifNotExists​(Class<B> otherClass, BiJoiner<A,​B> joiner)` | Create a new `UniConstraintStream` for every A where B does not exist for which the `BiJoiner` is true (for the properties it extracts from both facts).
    `<B> UniConstraintStream<A>` | `ifNotExists​(Class<B> otherClass, BiJoiner<A,​B>... joiners)` | As defined by `ifNotExists(Class, BiJoiner)`.
    `default <B> UniConstraintStream<A>` | `ifNotExists​(Class<B> otherClass, BiJoiner<A,​B> joiner1, BiJoiner<A,​B> joiner2)` | As defined by `ifNotExists(Class, BiJoiner)`.
    `default <B> UniConstraintStream<A>` | `ifNotExists​(Class<B> otherClass, BiJoiner<A,​B> joiner1, BiJoiner<A,​B> joiner2, BiJoiner<A,​B> joiner3)` | As defined by `ifNotExists(Class, BiJoiner)`.
    `default <B> UniConstraintStream<A>` | `ifNotExists​(Class<B> otherClass, BiJoiner<A,​B> joiner1, BiJoiner<A,​B> joiner2, BiJoiner<A,​B> joiner3, BiJoiner<A,​B> joiner4)` | As defined by `ifNotExists(Class, BiJoiner)`.
    `default UniConstraintStream<A>` | `ifNotExistsOther​(Class<A> otherClass)` | Create a new `UniConstraintStream` for every A, if no other A exists that does not `#equals(Object)` the first.
    `default UniConstraintStream<A>` | `ifNotExistsOther​(Class<A> otherClass, BiJoiner<A,​A> joiner)` | Create a new `UniConstraintStream` for every A, if no other A exists that does not `#equals(Object)` the first, and for which the `BiJoiner` is true (for the properties it extracts from both facts).
    `default UniConstraintStream<A>` | `ifNotExistsOther​(Class<A> otherClass, BiJoiner<A,​A>... joiners)` | As defined by `ifNotExistsOther(Class, BiJoiner)`.
    `default UniConstraintStream<A>` | `ifNotExistsOther​(Class<A> otherClass, BiJoiner<A,​A> joiner1, BiJoiner<A,​A> joiner2)` | As defined by `ifNotExistsOther(Class, BiJoiner)`.
    `default UniConstraintStream<A>` | `ifNotExistsOther​(Class<A> otherClass, BiJoiner<A,​A> joiner1, BiJoiner<A,​A> joiner2, BiJoiner<A,​A> joiner3)` | As defined by `ifNotExistsOther(Class, BiJoiner)`.
    `default UniConstraintStream<A>` | `ifNotExistsOther​(Class<A> otherClass, BiJoiner<A,​A> joiner1, BiJoiner<A,​A> joiner2, BiJoiner<A,​A> joiner3, BiJoiner<A,​A> joiner4)` | As defined by `ifNotExistsOther(Class, BiJoiner)`.
    `Constraint` | `impact​(String constraintPackage, String constraintName, Score<?> constraintWeight, ToIntFunction<A> matchWeigher)` | As defined by `impact(String, Score, ToIntFunction)`.
    `default Constraint` | `impact​(String constraintName, Score<?> constraintWeight, ToIntFunction<A> matchWeigher)` | Positively or negatively impact the `Score` by the constraintWeight multiplied by the match weight.
    `Constraint` | `impactBigDecimal​(String constraintPackage, String constraintName, Score<?> constraintWeight, Function<A,​BigDecimal> matchWeigher)` | As defined by `impactBigDecimal(String, Score, Function)`.
    `default Constraint` | `impactBigDecimal​(String constraintName, Score<?> constraintWeight, Function<A,​BigDecimal> matchWeigher)` | Positively or negatively impact the `Score` by the constraintWeight multiplied by the match weight.
    `Constraint` | `impactConfigurable​(String constraintPackage, String constraintName, ToIntFunction<A> matchWeigher)` | As defined by `impactConfigurable(String, ToIntFunction)`.
    `default Constraint` | `impactConfigurable​(String constraintName, ToIntFunction<A> matchWeigher)` | Positively or negatively impact the `Score` by the `ConstraintWeight` multiplied by the match weight.
    `Constraint` | `impactConfigurableBigDecimal​(String constraintPackage, String constraintName, Function<A,​BigDecimal> matchWeigher)` | As defined by `impactConfigurableBigDecimal(String, Function)`.
    `default Constraint` | `impactConfigurableBigDecimal​(String constraintName, Function<A,​BigDecimal> matchWeigher)` | Positively or negatively impact the `Score` by the `ConstraintWeight` multiplied by the match weight.
    `Constraint` | `impactConfigurableLong​(String constraintPackage, String constraintName, ToLongFunction<A> matchWeigher)` | As defined by `impactConfigurableLong(String, ToLongFunction)`.
    `default Constraint` | `impactConfigurableLong​(String constraintName, ToLongFunction<A> matchWeigher)` | Positively or negatively impact the `Score` by the `ConstraintWeight` multiplied by the match weight.
    `Constraint` | `impactLong​(String constraintPackage, String constraintName, Score<?> constraintWeight, ToLongFunction<A> matchWeigher)` | As defined by `impactLong(String, Score, ToLongFunction)`.
    `default Constraint` | `impactLong​(String constraintName, Score<?> constraintWeight, ToLongFunction<A> matchWeigher)` | Positively or negatively impact the `Score` by the constraintWeight multiplied by the match weight.
    `default <B> BiConstraintStream<A,​B>` | `join​(Class<B> otherClass)` | Create a new `BiConstraintStream` for every combination of A and B.
    `default <B> BiConstraintStream<A,​B>` | `join​(Class<B> otherClass, BiJoiner<A,​B> joiner)` | Create a new `BiConstraintStream` for every combination of A and B for which the `BiJoiner` is true (for the properties it extracts from both facts).
    `default <B> BiConstraintStream<A,​B>` | `join​(Class<B> otherClass, BiJoiner<A,​B>... joiners)` | As defined by `join(Class, BiJoiner)`.
    `default <B> BiConstraintStream<A,​B>` | `join​(Class<B> otherClass, BiJoiner<A,​B> joiner1, BiJoiner<A,​B> joiner2)` | As defined by `join(Class, BiJoiner)`.
    `default <B> BiConstraintStream<A,​B>` | `join​(Class<B> otherClass, BiJoiner<A,​B> joiner1, BiJoiner<A,​B> joiner2, BiJoiner<A,​B> joiner3)` | As defined by `join(Class, BiJoiner)`.
    `default <B> BiConstraintStream<A,​B>` | `join​(Class<B> otherClass, BiJoiner<A,​B> joiner1, BiJoiner<A,​B> joiner2, BiJoiner<A,​B> joiner3, BiJoiner<A,​B> joiner4)` | As defined by `join(Class, BiJoiner)`.
    `default <B> BiConstraintStream<A,​B>` | `join​(UniConstraintStream<B> otherStream)` | Create a new `BiConstraintStream` for every combination of A and B.
    `<B> BiConstraintStream<A,​B>` | `join​(UniConstraintStream<B> otherStream, BiJoiner<A,​B> joiner)` | Create a new `BiConstraintStream` for every combination of A and B for which the `BiJoiner` is true (for the properties it extracts from both facts).
    `Constraint` | `penalize​(String constraintPackage, String constraintName, Score<?> constraintWeight, ToIntFunction<A> matchWeigher)` | As defined by `penalize(String, Score, ToIntFunction)`.
    `default Constraint` | `penalize​(String constraintName, Score<?> constraintWeight, ToIntFunction<A> matchWeigher)` | Negatively impact the `Score`: subtract the constraintWeight multiplied by the match weight.
    `Constraint` | `penalizeBigDecimal​(String constraintPackage, String constraintName, Score<?> constraintWeight, Function<A,​BigDecimal> matchWeigher)` | As defined by `penalizeBigDecimal(String, Score, Function)`.
    `default Constraint` | `penalizeBigDecimal​(String constraintName, Score<?> constraintWeight, Function<A,​BigDecimal> matchWeigher)` | Negatively impact the `Score`: subtract the constraintWeight multiplied by the match weight.
    `Constraint` | `penalizeConfigurable​(String constraintPackage, String constraintName, ToIntFunction<A> matchWeigher)` | As defined by `penalizeConfigurable(String, ToIntFunction)`.
    `default Constraint` | `penalizeConfigurable​(String constraintName, ToIntFunction<A> matchWeigher)` | Negatively impact the `Score`: subtract the `ConstraintWeight` multiplied by the match weight.
    `Constraint` | `penalizeConfigurableBigDecimal​(String constraintPackage, String constraintName, Function<A,​BigDecimal> matchWeigher)` | As defined by `penalizeConfigurableBigDecimal(String, Function)`.
    `default Constraint` | `penalizeConfigurableBigDecimal​(String constraintName, Function<A,​BigDecimal> matchWeigher)` | Negatively impact the `Score`: subtract the `ConstraintWeight` multiplied by the match weight.
    `Constraint` | `penalizeConfigurableLong​(String constraintPackage, String constraintName, ToLongFunction<A> matchWeigher)` | As defined by `penalizeConfigurableLong(String, ToLongFunction)`.
    `default Constraint` | `penalizeConfigurableLong​(String constraintName, ToLongFunction<A> matchWeigher)` | Negatively impact the `Score`: subtract the `ConstraintWeight` multiplied by the match weight.
    `Constraint` | `penalizeLong​(String constraintPackage, String constraintName, Score<?> constraintWeight, ToLongFunction<A> matchWeigher)` | As defined by `penalizeLong(String, Score, ToLongFunction)`.
    `default Constraint` | `penalizeLong​(String constraintName, Score<?> constraintWeight, ToLongFunction<A> matchWeigher)` | Negatively impact the `Score`: subtract the constraintWeight multiplied by the match weight.
    `Constraint` | `reward​(String constraintPackage, String constraintName, Score<?> constraintWeight, ToIntFunction<A> matchWeigher)` | As defined by `reward(String, Score, ToIntFunction)`.
    `default Constraint` | `reward​(String constraintName, Score<?> constraintWeight, ToIntFunction<A> matchWeigher)` | Positively impact the `Score`: add the constraintWeight multiplied by the match weight.
    `Constraint` | `rewardBigDecimal​(String constraintPackage, String constraintName, Score<?> constraintWeight, Function<A,​BigDecimal> matchWeigher)` | As defined by `rewardBigDecimal(String, Score, Function)`.
    `default Constraint` | `rewardBigDecimal​(String constraintName, Score<?> constraintWeight, Function<A,​BigDecimal> matchWeigher)` | Positively impact the `Score`: add the constraintWeight multiplied by the match weight.
    `Constraint` | `rewardConfigurable​(String constraintPackage, String constraintName, ToIntFunction<A> matchWeigher)` | As defined by `rewardConfigurable(String, ToIntFunction)`.
    `default Constraint` | `rewardConfigurable​(String constraintName, ToIntFunction<A> matchWeigher)` | Positively impact the `Score`: add the `ConstraintWeight` multiplied by the match weight.
    `Constraint` | `rewardConfigurableBigDecimal​(String constraintPackage, String constraintName, Function<A,​BigDecimal> matchWeigher)` | As defined by `rewardConfigurableBigDecimal(String, Function)`.
    `default Constraint` | `rewardConfigurableBigDecimal​(String constraintName, Function<A,​BigDecimal> matchWeigher)` | Positively impact the `Score`: add the `ConstraintWeight` multiplied by the match weight.
    `Constraint` | `rewardConfigurableLong​(String constraintPackage, String constraintName, ToLongFunction<A> matchWeigher)` | As defined by `rewardConfigurableLong(String, ToLongFunction)`.
    `default Constraint` | `rewardConfigurableLong​(String constraintName, ToLongFunction<A> matchWeigher)` | Positively impact the `Score`: add the `ConstraintWeight` multiplied by the match weight.
    `Constraint` | `rewardLong​(String constraintPackage, String constraintName, Score<?> constraintWeight, ToLongFunction<A> matchWeigher)` | As defined by `rewardLong(String, Score, ToLongFunction)`.
    `default Constraint` | `rewardLong​(String constraintName, Score<?> constraintWeight, ToLongFunction<A> matchWeigher)` | Positively impact the `Score`: add the constraintWeight multiplied by the match weight.

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.ConstraintStream

      `getConstraintFactory, impact, impact, penalize, penalize, penalizeConfigurable, penalizeConfigurable, reward, reward, rewardConfigurable, rewardConfigurable`

- - ### Method Detail

    - #### filter

          UniConstraintStream<A> filter​(Predicate<A> predicate)

      Exhaustively test each fact against the `Predicate` and match if `Predicate.test(Object)` returns true.
      Parameters:
        `predicate` - never null
      Returns:
        never null

    - #### join

          default <B> BiConstraintStream<A,​B> join​(UniConstraintStream<B> otherStream)

      Create a new `BiConstraintStream` for every combination of A and B.

      Important: `Filtering` this is slower and less scalable than a `join(UniConstraintStream, BiJoiner)`, because it doesn't apply hashing and/or indexing on the properties, so it creates and checks every combination of A and B.

      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherStream` - never null
      Returns:
        never null, a stream that matches every combination of A and B

    - #### join

          <B> BiConstraintStream<A,​B> join​(UniConstraintStream<B> otherStream,
                                                 BiJoiner<A,​B> joiner)

      Create a new `BiConstraintStream` for every combination of A and B for which the `BiJoiner` is true (for the properties it extracts from both facts).

      Important: This is faster and more scalable than a `join` followed by a `filter`, because it applies hashing and/or indexing on the properties, so it doesn't create nor checks every combination of A and B.

      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherStream` - never null
        `joiner` - never null
      Returns:
        never null, a stream that matches every combination of A and B for which the `BiJoiner` is true

    - #### join

          default <B> BiConstraintStream<A,​B> join​(Class<B> otherClass)

      Create a new `BiConstraintStream` for every combination of A and B.

      Important: `Filtering` this is slower and less scalable than a `join(Class, BiJoiner)`, because it doesn't apply hashing and/or indexing on the properties, so it creates and checks every combination of A and B.

      This method is syntactic sugar for `join(UniConstraintStream)`.

      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
      Returns:
        never null, a stream that matches every combination of A and B

    - #### join

          default <B> BiConstraintStream<A,​B> join​(Class<B> otherClass,
                                                         BiJoiner<A,​B> joiner)

      Create a new `BiConstraintStream` for every combination of A and B for which the `BiJoiner` is true (for the properties it extracts from both facts).

      Important: This is faster and more scalable than a `join` followed by a `filter`, because it applies hashing and/or indexing on the properties, so it doesn't create nor checks every combination of A and B.

      This method is syntactic sugar for `join(UniConstraintStream, BiJoiner)`.

      This method has overloaded methods with multiple `BiJoiner` parameters.

      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiner` - never null
      Returns:
        never null, a stream that matches every combination of A and B for which the `BiJoiner` is true

    - #### join

          default <B> BiConstraintStream<A,​B> join​(Class<B> otherClass,
                                                         BiJoiner<A,​B> joiner1,
                                                         BiJoiner<A,​B> joiner2)

      As defined by `join(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
      Returns:
        never null, a stream that matches every combination of A and B for which all the `joiners` are true

    - #### join

          default <B> BiConstraintStream<A,​B> join​(Class<B> otherClass,
                                                         BiJoiner<A,​B> joiner1,
                                                         BiJoiner<A,​B> joiner2,
                                                         BiJoiner<A,​B> joiner3)

      As defined by `join(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
        `joiner3` - never null
      Returns:
        never null, a stream that matches every combination of A and B for which all the `joiners` are true

    - #### join

          default <B> BiConstraintStream<A,​B> join​(Class<B> otherClass,
                                                         BiJoiner<A,​B> joiner1,
                                                         BiJoiner<A,​B> joiner2,
                                                         BiJoiner<A,​B> joiner3,
                                                         BiJoiner<A,​B> joiner4)

      As defined by `join(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
        `joiner3` - never null
        `joiner4` - never null
      Returns:
        never null, a stream that matches every combination of A and B for which all the `joiners` are true

    - #### join

          default <B> BiConstraintStream<A,​B> join​(Class<B> otherClass,
                                                         BiJoiner<A,​B>... joiners)

      As defined by `join(Class, BiJoiner)`. If multiple `BiJoiner`s are provided, for performance reasons, the indexing joiners must be placed before filtering joiners.

      This method causes Unchecked generics array creation for varargs parameter warnings, but we can't fix it with a `SafeVarargs` annotation because it's an interface method. Therefore, there are overloaded methods with up to 4 `BiJoiner` parameters.

      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiners` - never null
      Returns:
        never null, a stream that matches every combination of A and B for which all the `joiners` are true

    - #### ifExists

          default <B> UniConstraintStream<A> ifExists​(Class<B> otherClass,
                                                      BiJoiner<A,​B> joiner)

      Create a new `UniConstraintStream` for every A where B exists for which the `BiJoiner` is true (for the properties it extracts from both facts).

      This method has overloaded methods with multiple `BiJoiner` parameters.

      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiner` - never null
      Returns:
        never null, a stream that matches every A where B exists for which the `BiJoiner` is true

    - #### ifExists

          default <B> UniConstraintStream<A> ifExists​(Class<B> otherClass,
                                                      BiJoiner<A,​B> joiner1,
                                                      BiJoiner<A,​B> joiner2)

      As defined by `ifExists(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
      Returns:
        never null, a stream that matches every A where B exists for which all the `BiJoiner`s are true

    - #### ifExists

          default <B> UniConstraintStream<A> ifExists​(Class<B> otherClass,
                                                      BiJoiner<A,​B> joiner1,
                                                      BiJoiner<A,​B> joiner2,
                                                      BiJoiner<A,​B> joiner3)

      As defined by `ifExists(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
        `joiner3` - never null
      Returns:
        never null, a stream that matches every A where B exists for which all the `BiJoiner`s are true

    - #### ifExists

          default <B> UniConstraintStream<A> ifExists​(Class<B> otherClass,
                                                      BiJoiner<A,​B> joiner1,
                                                      BiJoiner<A,​B> joiner2,
                                                      BiJoiner<A,​B> joiner3,
                                                      BiJoiner<A,​B> joiner4)

      As defined by `ifExists(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
        `joiner3` - never null
        `joiner4` - never null
      Returns:
        never null, a stream that matches every A where B exists for which all the `BiJoiner`s are true

    - #### ifExists

          <B> UniConstraintStream<A> ifExists​(Class<B> otherClass,
                                              BiJoiner<A,​B>... joiners)

      As defined by `ifExists(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.

      This method causes Unchecked generics array creation for varargs parameter warnings, but we can't fix it with a `SafeVarargs` annotation because it's an interface method. Therefore, there are overloaded methods with up to 4 `BiJoiner` parameters.

      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiners` - never null
      Returns:
        never null, a stream that matches every A where B exists for which all the `BiJoiner`s are true

    - #### ifExistsOther

          default UniConstraintStream<A> ifExistsOther​(Class<A> otherClass)

      Create a new `UniConstraintStream` for every A, if another A exists that does not `#equals(Object)` the first.
      Parameters:
        `otherClass` - never null
      Returns:
        never null, a stream that matches every A where a different A exists

    - #### ifExistsOther

          default UniConstraintStream<A> ifExistsOther​(Class<A> otherClass,
                                                       BiJoiner<A,​A> joiner)

      Create a new `UniConstraintStream` for every A, if another A exists that does not `#equals(Object)` the first, and for which the `BiJoiner` is true (for the properties it extracts from both facts).

      This method has overloaded methods with multiple `BiJoiner` parameters.

      Parameters:
        `otherClass` - never null
        `joiner` - never null
      Returns:
        never null, a stream that matches every A where a different A exists for which the `BiJoiner` is true

    - #### ifExistsOther

          default UniConstraintStream<A> ifExistsOther​(Class<A> otherClass,
                                                       BiJoiner<A,​A> joiner1,
                                                       BiJoiner<A,​A> joiner2)

      As defined by `ifExistsOther(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
      Returns:
        never null, a stream that matches every A where a different A exists for which all the `BiJoiner`s are true

    - #### ifExistsOther

          default UniConstraintStream<A> ifExistsOther​(Class<A> otherClass,
                                                       BiJoiner<A,​A> joiner1,
                                                       BiJoiner<A,​A> joiner2,
                                                       BiJoiner<A,​A> joiner3)

      As defined by `ifExistsOther(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
        `joiner3` - never null
      Returns:
        never null, a stream that matches every A where a different A exists for which all the `BiJoiner`s are true

    - #### ifExistsOther

          default UniConstraintStream<A> ifExistsOther​(Class<A> otherClass,
                                                       BiJoiner<A,​A> joiner1,
                                                       BiJoiner<A,​A> joiner2,
                                                       BiJoiner<A,​A> joiner3,
                                                       BiJoiner<A,​A> joiner4)

      As defined by `ifExistsOther(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
        `joiner3` - never null
        `joiner4` - never null
      Returns:
        never null, a stream that matches every A where a different A exists for which all the `BiJoiner`s are true

    - #### ifExistsOther

          default UniConstraintStream<A> ifExistsOther​(Class<A> otherClass,
                                                       BiJoiner<A,​A>... joiners)

      As defined by `ifExistsOther(Class, BiJoiner)`. If multiple `BiJoiner`s are provided, for performance reasons, the indexing joiners must be placed before filtering joiners.

      This method causes Unchecked generics array creation for varargs parameter warnings, but we can't fix it with a `SafeVarargs` annotation because it's an interface method. Therefore, there are overloaded methods with up to 4 `BiJoiner` parameters.

      Parameters:
        `otherClass` - never null
        `joiners` - never null
      Returns:
        never null, a stream that matches every A where a different A exists for which all the `BiJoiner`s are true

    - #### ifNotExists

          default <B> UniConstraintStream<A> ifNotExists​(Class<B> otherClass,
                                                         BiJoiner<A,​B> joiner)

      Create a new `UniConstraintStream` for every A where B does not exist for which the `BiJoiner` is true (for the properties it extracts from both facts).

      This method has overloaded methods with multiple `BiJoiner` parameters.

      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiner` - never null
      Returns:
        never null, a stream that matches every A where B does not exist for which the `BiJoiner` is true

    - #### ifNotExists

          default <B> UniConstraintStream<A> ifNotExists​(Class<B> otherClass,
                                                         BiJoiner<A,​B> joiner1,
                                                         BiJoiner<A,​B> joiner2)

      As defined by `ifNotExists(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
      Returns:
        never null, a stream that matches every A where B does not exist for which all the `BiJoiner`s are true

    - #### ifNotExists

          default <B> UniConstraintStream<A> ifNotExists​(Class<B> otherClass,
                                                         BiJoiner<A,​B> joiner1,
                                                         BiJoiner<A,​B> joiner2,
                                                         BiJoiner<A,​B> joiner3)

      As defined by `ifNotExists(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
        `joiner3` - never null
      Returns:
        never null, a stream that matches every A where B does not exist for which all the `BiJoiner`s are true

    - #### ifNotExists

          default <B> UniConstraintStream<A> ifNotExists​(Class<B> otherClass,
                                                         BiJoiner<A,​B> joiner1,
                                                         BiJoiner<A,​B> joiner2,
                                                         BiJoiner<A,​B> joiner3,
                                                         BiJoiner<A,​B> joiner4)

      As defined by `ifNotExists(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
        `joiner3` - never null
        `joiner4` - never null
      Returns:
        never null, a stream that matches every A where B does not exist for which all the `BiJoiner`s are true

    - #### ifNotExists

          <B> UniConstraintStream<A> ifNotExists​(Class<B> otherClass,
                                                 BiJoiner<A,​B>... joiners)

      As defined by `ifNotExists(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.

      This method causes Unchecked generics array creation for varargs parameter warnings, but we can't fix it with a `SafeVarargs` annotation because it's an interface method. Therefore, there are overloaded methods with up to 4 `BiJoiner` parameters.

      Type Parameters:
        `B` - the type of the second matched fact
      Parameters:
        `otherClass` - never null
        `joiners` - never null
      Returns:
        never null, a stream that matches every A where B does not exist for which all the `BiJoiner`s are true

    - #### ifNotExistsOther

          default UniConstraintStream<A> ifNotExistsOther​(Class<A> otherClass)

      Create a new `UniConstraintStream` for every A, if no other A exists that does not `#equals(Object)` the first.
      Parameters:
        `otherClass` - never null
      Returns:
        never null, a stream that matches every A where a different A does not exist

    - #### ifNotExistsOther

          default UniConstraintStream<A> ifNotExistsOther​(Class<A> otherClass,
                                                          BiJoiner<A,​A> joiner)

      Create a new `UniConstraintStream` for every A, if no other A exists that does not `#equals(Object)` the first, and for which the `BiJoiner` is true (for the properties it extracts from both facts).

      This method has overloaded methods with multiple `BiJoiner` parameters.

      Parameters:
        `otherClass` - never null
        `joiner` - never null
      Returns:
        never null, a stream that matches every A where a different A does not exist for which the `BiJoiner` is true

    - #### ifNotExistsOther

          default UniConstraintStream<A> ifNotExistsOther​(Class<A> otherClass,
                                                          BiJoiner<A,​A> joiner1,
                                                          BiJoiner<A,​A> joiner2)

      As defined by `ifNotExistsOther(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
      Returns:
        never null, a stream that matches every A where a different A does not exist for which all the `BiJoiner`s are true

    - #### ifNotExistsOther

          default UniConstraintStream<A> ifNotExistsOther​(Class<A> otherClass,
                                                          BiJoiner<A,​A> joiner1,
                                                          BiJoiner<A,​A> joiner2,
                                                          BiJoiner<A,​A> joiner3)

      As defined by `ifNotExistsOther(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
        `joiner3` - never null
      Returns:
        never null, a stream that matches every A where a different A does not exist for which all the `BiJoiner`s are true

    - #### ifNotExistsOther

          default UniConstraintStream<A> ifNotExistsOther​(Class<A> otherClass,
                                                          BiJoiner<A,​A> joiner1,
                                                          BiJoiner<A,​A> joiner2,
                                                          BiJoiner<A,​A> joiner3,
                                                          BiJoiner<A,​A> joiner4)

      As defined by `ifNotExistsOther(Class, BiJoiner)`. For performance reasons, indexing joiners must be placed before filtering joiners.
      Parameters:
        `otherClass` - never null
        `joiner1` - never null
        `joiner2` - never null
        `joiner3` - never null
        `joiner4` - never null
      Returns:
        never null, a stream that matches every A where a different A does not exist for which all the `BiJoiner`s are true

    - #### ifNotExistsOther

          default UniConstraintStream<A> ifNotExistsOther​(Class<A> otherClass,
                                                          BiJoiner<A,​A>... joiners)

      As defined by `ifNotExistsOther(Class, BiJoiner)`. If multiple `BiJoiner`s are provided, for performance reasons, the indexing joiners must be placed before filtering joiners.

      This method causes Unchecked generics array creation for varargs parameter warnings, but we can't fix it with a `SafeVarargs` annotation because it's an interface method. Therefore, there are overloaded methods with up to 4 `BiJoiner` parameters.

      Parameters:
        `otherClass` - never null
        `joiners` - never null
      Returns:
        never null, a stream that matches every A where a different A does not exist for which all the `BiJoiner`s are true

    - #### groupBy

          <ResultContainer_,​Result_> UniConstraintStream<Result_> groupBy​(UniConstraintCollector<A,​ResultContainer_,​Result_> collector)

      Convert the `UniConstraintStream` to a different `UniConstraintStream`, containing only a single tuple, the result of applying `UniConstraintCollector`.
      Type Parameters:
        `ResultContainer_` - the mutable accumulation type (often hidden as an implementation detail)
        `Result_` - the type of a fact in the destination `UniConstraintStream`'s tuple
      Parameters:
        `collector` - never null, the collector to perform the grouping operation with See `ConstraintCollectors` for common operations, such as `count()`, `sum()` and others.
      Returns:
        never null

    - #### groupBy

          <GroupKey_> UniConstraintStream<GroupKey_> groupBy​(Function<A,​GroupKey_> groupKeyMapping)

      Convert the `UniConstraintStream` to a different `UniConstraintStream`, containing the set of tuples resulting from applying the group key mapping function on all tuples of the original stream. Neither tuple of the new stream `Objects.equals(Object, Object)` any other.
      Type Parameters:
        `GroupKey_` - the type of a fact in the destination `UniConstraintStream`'s tuple
      Parameters:
        `groupKeyMapping` - never null, mapping function to convert each element in the stream to a different element
      Returns:
        never null

    - #### groupBy

          <GroupKey_,​ResultContainer_,​Result_> BiConstraintStream<GroupKey_,​Result_> groupBy​(Function<A,​GroupKey_> groupKeyMapping,
                                                                                                               UniConstraintCollector<A,​ResultContainer_,​Result_> collector)

      Convert the `UniConstraintStream` to a `BiConstraintStream`, consisting of unique tuples with two facts.

      The first fact is the return value of the first group key mapping function, applied on the incoming tuple. The second fact is the return value of a given `UniConstraintCollector` applied on all incoming tuples with the same first fact.

      Type Parameters:
        `GroupKey_` - the type of the first fact in the destination `BiConstraintStream`'s tuple
        `ResultContainer_` - the mutable accumulation type (often hidden as an implementation detail)
        `Result_` - the type of the second fact in the destination `BiConstraintStream`'s tuple
      Parameters:
        `groupKeyMapping` - never null, function to convert the fact in the original tuple to a different fact
        `collector` - never null, the collector to perform the grouping operation with See `ConstraintCollectors` for common operations, such as `count()`, `sum()` and others.
      Returns:
        never null

    - #### groupBy

          <GroupKeyA_,​GroupKeyB_> BiConstraintStream<GroupKeyA_,​GroupKeyB_> groupBy​(Function<A,​GroupKeyA_> groupKeyAMapping,
                                                                                                Function<A,​GroupKeyB_> groupKeyBMapping)

      Convert the `UniConstraintStream` to a `BiConstraintStream`, consisting of unique tuples with two facts.

      The first fact is the return value of the first group key mapping function, applied on the incoming tuple. The second fact is the return value of the second group key mapping function, applied on all incoming tuples with the same first fact.

      Type Parameters:
        `GroupKeyA_` - the type of the first fact in the destination `BiConstraintStream`'s tuple
        `GroupKeyB_` - the type of the second fact in the destination `BiConstraintStream`'s tuple
      Parameters:
        `groupKeyAMapping` - never null, function to convert the original tuple into a first fact
        `groupKeyBMapping` - never null, function to convert the original tuple into a second fact
      Returns:
        never null

    - #### groupBy

          <GroupKeyA_,​GroupKeyB_,​ResultContainer_,​Result_> TriConstraintStream<GroupKeyA_,​GroupKeyB_,​Result_> groupBy​(Function<A,​GroupKeyA_> groupKeyAMapping,
                                                                                                                                                    Function<A,​GroupKeyB_> groupKeyBMapping,
                                                                                                                                                    UniConstraintCollector<A,​ResultContainer_,​Result_> collector)

      Combines the semantics of `groupBy(Function, Function)` and `groupBy(UniConstraintCollector)`. That is, the first and second facts in the tuple follow the `groupBy(Function, Function)` semantics, and the third fact is the result of applying `UniConstraintCollector.finisher()` on all the tuples of the original `UniConstraintStream` that belong to the group.
      Type Parameters:
        `GroupKeyA_` - the type of the first fact in the destination `TriConstraintStream`'s tuple
        `GroupKeyB_` - the type of the second fact in the destination `TriConstraintStream`'s tuple
        `ResultContainer_` - the mutable accumulation type (often hidden as an implementation detail)
        `Result_` - the type of the third fact in the destination `TriConstraintStream`'s tuple
      Parameters:
        `groupKeyAMapping` - never null, function to convert the original tuple into a first fact
        `groupKeyBMapping` - never null, function to convert the original tuple into a second fact
        `collector` - never null, the collector to perform the grouping operation with See `ConstraintCollectors` for common operations, such as `count()`, `sum()` and others.
      Returns:
        never null

    - #### groupBy

          <GroupKeyA_,​GroupKeyB_,​ResultContainerC_,​ResultC_,​ResultContainerD_,​ResultD_> QuadConstraintStream<GroupKeyA_,​GroupKeyB_,​ResultC_,​ResultD_> groupBy​(Function<A,​GroupKeyA_> groupKeyAMapping,
                                                                                                                                                                                                              Function<A,​GroupKeyB_> groupKeyBMapping,
                                                                                                                                                                                                              UniConstraintCollector<A,​ResultContainerC_,​ResultC_> collectorC,
                                                                                                                                                                                                              UniConstraintCollector<A,​ResultContainerD_,​ResultD_> collectorD)

      Combines the semantics of `groupBy(Function, Function)` and `groupBy(UniConstraintCollector)`. That is, the first and second facts in the tuple follow the `groupBy(Function, Function)` semantics. The third fact is the result of applying the first `UniConstraintCollector.finisher()` on all the tuples of the original `UniConstraintStream` that belong to the group. The fourth fact is the result of applying the second `UniConstraintCollector.finisher()` on all the tuples of the original `UniConstraintStream` that belong to the group
      Type Parameters:
        `GroupKeyA_` - the type of the first fact in the destination `QuadConstraintStream`'s tuple
        `GroupKeyB_` - the type of the second fact in the destination `QuadConstraintStream`'s tuple
        `ResultContainerC_` - the mutable accumulation type (often hidden as an implementation detail)
        `ResultC_` - the type of the third fact in the destination `QuadConstraintStream`'s tuple
        `ResultContainerD_` - the mutable accumulation type (often hidden as an implementation detail)
        `ResultD_` - the type of the fourth fact in the destination `QuadConstraintStream`'s tuple
      Parameters:
        `groupKeyAMapping` - never null, function to convert the original tuple into a first fact
        `groupKeyBMapping` - never null, function to convert the original tuple into a second fact
        `collectorC` - never null, the collector to perform the first grouping operation with See `ConstraintCollectors` for common operations, such as `count()`, `sum()` and others.
        `collectorD` - never null, the collector to perform the second grouping operation with See `ConstraintCollectors` for common operations, such as `count()`, `sum()` and others.
      Returns:
        never null

    - #### penalize

          default Constraint penalize​(String constraintName,
                                      Score<?> constraintWeight,
                                      ToIntFunction<A> matchWeigher)

      Negatively impact the `Score`: subtract the constraintWeight multiplied by the match weight. Otherwise as defined by `ConstraintStream.penalize(String, Score)`.

      For non-int `Score` types use `penalizeLong(String, Score, ToLongFunction)` or `penalizeBigDecimal(String, Score, Function)` instead.

      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `constraintWeight` - never null
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### penalize

          Constraint penalize​(String constraintPackage,
                              String constraintName,
                              Score<?> constraintWeight,
                              ToIntFunction<A> matchWeigher)

      As defined by `penalize(String, Score, ToIntFunction)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `constraintWeight` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### penalizeLong

          default Constraint penalizeLong​(String constraintName,
                                          Score<?> constraintWeight,
                                          ToLongFunction<A> matchWeigher)

      Negatively impact the `Score`: subtract the constraintWeight multiplied by the match weight. Otherwise as defined by `ConstraintStream.penalize(String, Score)`.
      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `constraintWeight` - never null
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### penalizeLong

          Constraint penalizeLong​(String constraintPackage,
                                  String constraintName,
                                  Score<?> constraintWeight,
                                  ToLongFunction<A> matchWeigher)

      As defined by `penalizeLong(String, Score, ToLongFunction)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `constraintWeight` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### penalizeBigDecimal

          default Constraint penalizeBigDecimal​(String constraintName,
                                                Score<?> constraintWeight,
                                                Function<A,​BigDecimal> matchWeigher)

      Negatively impact the `Score`: subtract the constraintWeight multiplied by the match weight. Otherwise as defined by `ConstraintStream.penalize(String, Score)`.
      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `constraintWeight` - never null
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### penalizeBigDecimal

          Constraint penalizeBigDecimal​(String constraintPackage,
                                        String constraintName,
                                        Score<?> constraintWeight,
                                        Function<A,​BigDecimal> matchWeigher)

      As defined by `penalizeBigDecimal(String, Score, Function)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `constraintWeight` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### penalizeConfigurable

          default Constraint penalizeConfigurable​(String constraintName,
                                                  ToIntFunction<A> matchWeigher)

      Negatively impact the `Score`: subtract the `ConstraintWeight` multiplied by the match weight. Otherwise as defined by `ConstraintStream.penalizeConfigurable(String)`.

      For non-int `Score` types use `penalizeConfigurableLong(String, ToLongFunction)` or `penalizeConfigurableBigDecimal(String, Function)` instead.

      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### penalizeConfigurable

          Constraint penalizeConfigurable​(String constraintPackage,
                                          String constraintName,
                                          ToIntFunction<A> matchWeigher)

      As defined by `penalizeConfigurable(String, ToIntFunction)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### penalizeConfigurableLong

          default Constraint penalizeConfigurableLong​(String constraintName,
                                                      ToLongFunction<A> matchWeigher)

      Negatively impact the `Score`: subtract the `ConstraintWeight` multiplied by the match weight. Otherwise as defined by `ConstraintStream.penalizeConfigurable(String)`.
      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### penalizeConfigurableLong

          Constraint penalizeConfigurableLong​(String constraintPackage,
                                              String constraintName,
                                              ToLongFunction<A> matchWeigher)

      As defined by `penalizeConfigurableLong(String, ToLongFunction)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### penalizeConfigurableBigDecimal

          default Constraint penalizeConfigurableBigDecimal​(String constraintName,
                                                            Function<A,​BigDecimal> matchWeigher)

      Negatively impact the `Score`: subtract the `ConstraintWeight` multiplied by the match weight. Otherwise as defined by `ConstraintStream.penalizeConfigurable(String)`.
      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### penalizeConfigurableBigDecimal

          Constraint penalizeConfigurableBigDecimal​(String constraintPackage,
                                                    String constraintName,
                                                    Function<A,​BigDecimal> matchWeigher)

      As defined by `penalizeConfigurableBigDecimal(String, Function)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### reward

          default Constraint reward​(String constraintName,
                                    Score<?> constraintWeight,
                                    ToIntFunction<A> matchWeigher)

      Positively impact the `Score`: add the constraintWeight multiplied by the match weight. Otherwise as defined by `ConstraintStream.reward(String, Score)`.

      For non-int `Score` types use `rewardLong(String, Score, ToLongFunction)` or `rewardBigDecimal(String, Score, Function)` instead.

      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `constraintWeight` - never null
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### reward

          Constraint reward​(String constraintPackage,
                            String constraintName,
                            Score<?> constraintWeight,
                            ToIntFunction<A> matchWeigher)

      As defined by `reward(String, Score, ToIntFunction)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `constraintWeight` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### rewardLong

          default Constraint rewardLong​(String constraintName,
                                        Score<?> constraintWeight,
                                        ToLongFunction<A> matchWeigher)

      Positively impact the `Score`: add the constraintWeight multiplied by the match weight. Otherwise as defined by `ConstraintStream.reward(String, Score)`.
      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `constraintWeight` - never null
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### rewardLong

          Constraint rewardLong​(String constraintPackage,
                                String constraintName,
                                Score<?> constraintWeight,
                                ToLongFunction<A> matchWeigher)

      As defined by `rewardLong(String, Score, ToLongFunction)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `constraintWeight` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### rewardBigDecimal

          default Constraint rewardBigDecimal​(String constraintName,
                                              Score<?> constraintWeight,
                                              Function<A,​BigDecimal> matchWeigher)

      Positively impact the `Score`: add the constraintWeight multiplied by the match weight. Otherwise as defined by `ConstraintStream.reward(String, Score)`.
      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `constraintWeight` - never null
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### rewardBigDecimal

          Constraint rewardBigDecimal​(String constraintPackage,
                                      String constraintName,
                                      Score<?> constraintWeight,
                                      Function<A,​BigDecimal> matchWeigher)

      As defined by `rewardBigDecimal(String, Score, Function)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `constraintWeight` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### rewardConfigurable

          default Constraint rewardConfigurable​(String constraintName,
                                                ToIntFunction<A> matchWeigher)

      Positively impact the `Score`: add the `ConstraintWeight` multiplied by the match weight. Otherwise as defined by `ConstraintStream.rewardConfigurable(String)`.

      For non-int `Score` types use `rewardConfigurableLong(String, ToLongFunction)` or `rewardConfigurableBigDecimal(String, Function)` instead.

      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### rewardConfigurable

          Constraint rewardConfigurable​(String constraintPackage,
                                        String constraintName,
                                        ToIntFunction<A> matchWeigher)

      As defined by `rewardConfigurable(String, ToIntFunction)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### rewardConfigurableLong

          default Constraint rewardConfigurableLong​(String constraintName,
                                                    ToLongFunction<A> matchWeigher)

      Positively impact the `Score`: add the `ConstraintWeight` multiplied by the match weight. Otherwise as defined by `ConstraintStream.rewardConfigurable(String)`.
      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### rewardConfigurableLong

          Constraint rewardConfigurableLong​(String constraintPackage,
                                            String constraintName,
                                            ToLongFunction<A> matchWeigher)

      As defined by `rewardConfigurableLong(String, ToLongFunction)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### rewardConfigurableBigDecimal

          default Constraint rewardConfigurableBigDecimal​(String constraintName,
                                                          Function<A,​BigDecimal> matchWeigher)

      Positively impact the `Score`: add the `ConstraintWeight` multiplied by the match weight. Otherwise as defined by `ConstraintStream.rewardConfigurable(String)`.
      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### rewardConfigurableBigDecimal

          Constraint rewardConfigurableBigDecimal​(String constraintPackage,
                                                  String constraintName,
                                                  Function<A,​BigDecimal> matchWeigher)

      As defined by `rewardConfigurableBigDecimal(String, Function)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### impact

          default Constraint impact​(String constraintName,
                                    Score<?> constraintWeight,
                                    ToIntFunction<A> matchWeigher)

      Positively or negatively impact the `Score` by the constraintWeight multiplied by the match weight. Otherwise as defined by `ConstraintStream.impact(String, Score)`.

      Use `penalize(...)` or `reward(...)` instead, unless this constraint can both have positive and negative weights.

      For non-int `Score` types use `impactLong(String, Score, ToLongFunction)` or `impactBigDecimal(String, Score, Function)` instead.

      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `constraintWeight` - never null
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### impact

          Constraint impact​(String constraintPackage,
                            String constraintName,
                            Score<?> constraintWeight,
                            ToIntFunction<A> matchWeigher)

      As defined by `impact(String, Score, ToIntFunction)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `constraintWeight` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### impactLong

          default Constraint impactLong​(String constraintName,
                                        Score<?> constraintWeight,
                                        ToLongFunction<A> matchWeigher)

      Positively or negatively impact the `Score` by the constraintWeight multiplied by the match weight. Otherwise as defined by `ConstraintStream.impact(String, Score)`.

      Use `penalizeLong(...)` or `rewardLong(...)` instead, unless this constraint can both have positive and negative weights.

      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `constraintWeight` - never null
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### impactLong

          Constraint impactLong​(String constraintPackage,
                                String constraintName,
                                Score<?> constraintWeight,
                                ToLongFunction<A> matchWeigher)

      As defined by `impactLong(String, Score, ToLongFunction)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `constraintWeight` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### impactBigDecimal

          default Constraint impactBigDecimal​(String constraintName,
                                              Score<?> constraintWeight,
                                              Function<A,​BigDecimal> matchWeigher)

      Positively or negatively impact the `Score` by the constraintWeight multiplied by the match weight. Otherwise as defined by `ConstraintStream.impact(String, Score)`.

      Use `penalizeBigDecimal(...)` or `rewardBigDecimal(...)` instead, unless this constraint can both have positive and negative weights.

      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `constraintWeight` - never null
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### impactBigDecimal

          Constraint impactBigDecimal​(String constraintPackage,
                                      String constraintName,
                                      Score<?> constraintWeight,
                                      Function<A,​BigDecimal> matchWeigher)

      As defined by `impactBigDecimal(String, Score, Function)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `constraintWeight` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### impactConfigurable

          default Constraint impactConfigurable​(String constraintName,
                                                ToIntFunction<A> matchWeigher)

      Positively or negatively impact the `Score` by the `ConstraintWeight` multiplied by the match weight.

      Use `penalizeConfigurable(...)` or `rewardConfigurable(...)` instead, unless this constraint can both have positive and negative weights.

      The constraintWeight comes from an `ConstraintWeight` annotated member on the `ConstraintConfiguration`, so end users can change the constraint weights dynamically. This constraint may be deactivated if the `ConstraintWeight` is zero. If there is no `ConstraintConfiguration`, use `ConstraintStream.impact(String, Score)` instead.

      For non-int `Score` types use `impactConfigurableLong(String, ToLongFunction)` or `impactConfigurableBigDecimal(String, Function)` instead.

      The `Constraint.getConstraintPackage()` defaults to `ConstraintConfiguration.constraintPackage()`.

      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### impactConfigurable

          Constraint impactConfigurable​(String constraintPackage,
                                        String constraintName,
                                        ToIntFunction<A> matchWeigher)

      As defined by `impactConfigurable(String, ToIntFunction)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### impactConfigurableLong

          default Constraint impactConfigurableLong​(String constraintName,
                                                    ToLongFunction<A> matchWeigher)

      Positively or negatively impact the `Score` by the `ConstraintWeight` multiplied by the match weight.

      Use `penalizeConfigurableLong(...)` or `rewardConfigurableLong(...)` instead, unless this constraint can both have positive and negative weights.

      The constraintWeight comes from an `ConstraintWeight` annotated member on the `ConstraintConfiguration`, so end users can change the constraint weights dynamically. This constraint may be deactivated if the `ConstraintWeight` is zero. If there is no `ConstraintConfiguration`, use `ConstraintStream.impact(String, Score)` instead.

      The `Constraint.getConstraintPackage()` defaults to `ConstraintConfiguration.constraintPackage()`.

      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### impactConfigurableLong

          Constraint impactConfigurableLong​(String constraintPackage,
                                            String constraintName,
                                            ToLongFunction<A> matchWeigher)

      As defined by `impactConfigurableLong(String, ToLongFunction)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `matchWeigher` - never null
      Returns:
        never null

    - #### impactConfigurableBigDecimal

          default Constraint impactConfigurableBigDecimal​(String constraintName,
                                                          Function<A,​BigDecimal> matchWeigher)

      Positively or negatively impact the `Score` by the `ConstraintWeight` multiplied by the match weight.

      Use `penalizeConfigurableBigDecimal(...)` or `rewardConfigurableBigDecimal(...)` instead, unless this constraint can both have positive and negative weights.

      The constraintWeight comes from an `ConstraintWeight` annotated member on the `ConstraintConfiguration`, so end users can change the constraint weights dynamically. This constraint may be deactivated if the `ConstraintWeight` is zero. If there is no `ConstraintConfiguration`, use `ConstraintStream.impact(String, Score)` instead.

      The `Constraint.getConstraintPackage()` defaults to `ConstraintConfiguration.constraintPackage()`.

      Parameters:
        `constraintName` - never null, shows up in `ConstraintMatchTotal` during score justification
        `matchWeigher` - never null, the result of this function (matchWeight) is multiplied by the constraintWeight
      Returns:
        never null

    - #### impactConfigurableBigDecimal

          Constraint impactConfigurableBigDecimal​(String constraintPackage,
                                                  String constraintName,
                                                  Function<A,​BigDecimal> matchWeigher)

      As defined by `impactConfigurableBigDecimal(String, Function)`.
      Parameters:
        `constraintPackage` - never null
        `constraintName` - never null
        `matchWeigher` - never null
      Returns:
        never null